import http from "k6/http";
import { check, sleep } from "k6";
import { htmlReport } from "https://raw.githubusercontent.com/benc-uk/k6-reporter/main/dist/bundle.js";

export const options = {
    vus: 50,
    duration: "1m",
};

export function setup() {
    let res = http.get("http://localhost:8080/init");
    check(res, {
        "status is 200": (r) => r.status === 200,
    });
}

export function handleSummary(data) {
    return {
        "summary.html": htmlReport(data),
    };
}

export default function() {
    let randomTitle = Math.random().toString(36).substring(7);
    let randomCompleted = Math.random() >= 0.5; // génère un booléen aléatoire

    let body = {
        title: randomTitle,
        completed: randomCompleted
    }

    let res = http.post(
        "http://localhost:8080/create_todo",
        JSON.stringify(body),
        { headers: { "Content-type": "application/json" } }
    );
    check(res, {
        "status was 200": (r) => r.status == 200
    });

    let getRes = http.get("http://localhost:8080/todos");
    check(getRes, {
        "status was 200": (r) => r.status == 200
    });

    sleep(0.1); // dormir pendant 100ms avant de faire la prochaine requête
}